package sega.a7;

import javacard.security.MessageDigest;

public class GkeyWrite extends AuthCommand {
    private static final short RECV_PACKET_SIZE = 78;
    private static final byte AUTH_LEVEL = 2;
    private static final short PARAM_SIZE = 46;

    public GkeyWrite(short cmd, AppData data, MakePacket packet, MessageDigest sha1, HmacSha1 hmacSha1, Crypt crypt) {
        super(cmd, RECV_PACKET_SIZE, PARAM_SIZE, AUTH_LEVEL, data, packet, sha1, hmacSha1, crypt);
    }

    public short core(byte[] data, short dataOffset, short dataLength) {
        if (this.m_ee_data.getSflag_ee())
            return AppConfig.A7_EEPWRITE_DISABLE;

        short ramD_dataSize = AppConfig.AES_KEY_SIZE + AppConfig.AES_IV_SIZE;
        byte[] ramD_newGKey = this.m_ee_data.getGeneralBuffer_ramD();
        if (ramD_newGKey.length < (short) ramD_dataSize)
            return AppConfig.A7_FAIL;

        short ramD_decSize = decData(data, (short) (dataOffset + 6), ramD_dataSize, ramD_newGKey, (short) 0);

        if (ramD_decSize < 32)
            return AppConfig.A7_FAIL;

        if (!changeGKey_ee(ramD_newGKey, (short) 0, AppConfig.AES_KEY_SIZE, ramD_newGKey, AppConfig.AES_KEY_SIZE,
                AppConfig.AES_IV_SIZE))
            return AppConfig.A7_EEP_WRITEFAIL;

        return AppConfig.A7_SUCCESS;
    }
}
