package sega.a7;

import javacard.security.MessageDigest;

public class KeychipInfoWrite extends AuthCommand {
    private static final short RECV_PACKET_SIZE = 142;
    private static final byte AUTH_LEVEL = 2;
    private static final short PARAM_SIZE = 46;

    public KeychipInfoWrite(short cmd, AppData data, MakePacket packet, MessageDigest sha1, HmacSha1 hmacSha1,
            Crypt crypt) {
        super(cmd, RECV_PACKET_SIZE, PARAM_SIZE, AUTH_LEVEL, data, packet, sha1, hmacSha1, crypt);
    }

    public short core(byte[] data, short dataOffset, short dataLength) {
        if (this.m_ee_data.getSflag_ee())
            return AppConfig.A7_EEPWRITE_DISABLE;

        short ramD_dataSize = AppConfig.KEYCHIP_INFO_SIZE;
        byte[] ramD_newKeychipInfo = this.m_ee_data.getGeneralBuffer_ramD();
        if (ramD_newKeychipInfo.length < ramD_dataSize)
            return AppConfig.A7_FAIL;

        short ramD_decSize = decData(data, (short) (AppConfig.HEADER_SIZE + dataOffset), ramD_dataSize, ramD_newKeychipInfo,
                (short) 0);
        if (ramD_dataSize > ramD_decSize)
            return AppConfig.A7_FAIL;

            if (!this.m_ee_data.setKeychipInfo_ee(ramD_newKeychipInfo, (short) 0, ramD_decSize))
            return AppConfig.A7_EEP_WRITEFAIL;
        return AppConfig.A7_SUCCESS;
    }
}
