package sega.a7;

import javacard.framework.Util;
import javacard.security.MessageDigest;
import javacard.security.RandomData;

public class RanGet extends AuthCommand {
    private static final short RECV_PACKET_SIZE = 46;
    private static final byte AUTH_LEVEL = 2;
    private static final short PARAM_SIZE = 62;
    private static final short RAN_SIZE = 16;

    private RandomData m_ee_rand;

    public RanGet(short cmd, AppData data, MakePacket packet, MessageDigest sha1, HmacSha1 hmacSha1, Crypt crypt,
            RandomData rand) {
        super(cmd, RECV_PACKET_SIZE, PARAM_SIZE, AUTH_LEVEL, data, packet, sha1, hmacSha1, crypt);
        this.m_ee_rand = rand;
    }

    public short core(byte[] data, short dataOffset, short dataLength) {
        byte[] ramD_ranData = this.m_ee_data.getGeneralBuffer_ramD();
        if (ramD_ranData.length < 32)
            return AppConfig.A7_FAIL;

        this.m_ee_rand.generateData(ramD_ranData, (short) 0, RAN_SIZE);
        short ramD_encSize = encData(ramD_ranData, (short) 0, RAN_SIZE, ramD_ranData, RAN_SIZE);
        if (ramD_encSize != 16)
            return AppConfig.A7_FAIL;

        this.m_ramD_outDataInfo[0] = RAN_SIZE;
        this.m_ramD_outDataInfo[1] = ramD_encSize;
        Util.arrayCopyNonAtomic(ramD_ranData, this.m_ramD_outDataInfo[0], this.m_ramD_outData,
                this.m_ramD_outDataInfo[0], this.m_ramD_outDataInfo[1]);
        return AppConfig.A7_SUCCESS;
    }
}
