package sega.a7;

import javacard.security.MessageDigest;

public class TraceDataInfoWrite extends AuthCommand {
    private static final short RECV_PACKET_SIZE = 62;
    private static final byte AUTH_LEVEL = 2;
    private static final short PARAM_SIZE = 46;

    public TraceDataInfoWrite(short cmd, AppData data, MakePacket packet, MessageDigest sha1, HmacSha1 hmacSha1,
            Crypt crypt) {
        super(cmd, RECV_PACKET_SIZE, PARAM_SIZE, AUTH_LEVEL, data, packet, sha1, hmacSha1, crypt);
    }

    public short core(byte[] data, short dataOffset, short dataLength) {
        short ramD_dataSize = 16;
        byte[] ramD_newTraceDataInfo = this.m_ee_data.getGeneralBuffer_ramD();
        if (ramD_newTraceDataInfo.length < ramD_dataSize)
            return AppConfig.A7_FAIL;

        short ramD_decSize = decData(data, (short) (dataOffset + 6), ramD_dataSize, ramD_newTraceDataInfo, (short) 0);

        if (ramD_decSize < ramD_dataSize)
            return AppConfig.A7_FAIL;

        if (!this.m_ee_data.setTraceDataInfo_ee(ramD_newTraceDataInfo, (short) 0, ramD_decSize))
            return AppConfig.A7_EEP_WRITEFAIL;
        return AppConfig.A7_SUCCESS;
    }
}
