package sega.a7;

import javacard.framework.Util;
import javacard.security.MessageDigest;

public class UdataRead extends AuthCommand {
    private static final short RECV_PACKET_SIZE = 46;
    private static final byte AUTH_LEVEL = 2;
    private static final short PARAM_SIZE = 62;

    public UdataRead(short cmd, AppData data, MakePacket packet, MessageDigest sha1, HmacSha1 hmacSha1, Crypt crypt) {
        super(cmd, RECV_PACKET_SIZE, PARAM_SIZE, AUTH_LEVEL, data, packet, sha1, hmacSha1, crypt);
    }

    public short core(byte[] data, short dataOffset, short dataLength) {
        byte[] ee_udata = this.m_ee_data.getUdata_ee();
        byte[] ramD_encUdata = this.m_ee_data.getGeneralBuffer_ramD();
        if (ramD_encUdata.length < ee_udata.length)
            return AppConfig.A7_FAIL;

        short ramD_encSize = encData(ee_udata, (short) 0, (short) ee_udata.length, ramD_encUdata, (short) 0);
        if (ramD_encSize < ee_udata.length)
            return AppConfig.A7_FAIL;

        this.m_ramD_outDataInfo[AppConfig.SEND_BUUFER_INFO_OFFSET] = 0;
        this.m_ramD_outDataInfo[AppConfig.SEND_BUUFER_INFO_SIZE] = ramD_encSize;
        Util.arrayCopyNonAtomic(ramD_encUdata, this.m_ramD_outDataInfo[AppConfig.SEND_BUUFER_INFO_OFFSET],
                this.m_ramD_outData, this.m_ramD_outDataInfo[AppConfig.SEND_BUUFER_INFO_OFFSET],
                this.m_ramD_outDataInfo[AppConfig.SEND_BUUFER_INFO_SIZE]);

        return AppConfig.A7_SUCCESS;
    }
}
